#define USECHRONO
#include <cassert>
#include <climits>
#include <cstdlib>
#include <stack>
#include "eval.hpp"

using namespace aed;
using namespace std;

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void separate(vector<int> &v,vector<int> &even,
              vector<int> &odd)  {
  even.clear();
  odd.clear();
  int n=v.size();
  for (int j=0; j<n; j++) {
    int x=v[j];
    if (x%2==0) even.push_back(x);
    else odd.push_back(x);
  }
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool is_greater_than(vector<int> &v1,vector<int> &v2)  {
  // Retorna true si v1[j]>=v2[j] para todo j
  int n1=v1.size(), n2=v2.size();
  if (n1<n2) return false;
  bool rv = false;
  for (int j=0; j<n2; j++) {
    if (v1[j]<v2[j]) return false;
    if (v1[j]>v2[j]) rv = true;
  }
  return rv || n1>n2;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool is_greater_than2(vector<int> &v1,vector<int> &v2)  {
  // Retorna true si v1[j]>=v2[j] para todo j
  int n1=v1.size(), n2=v2.size();
  int m = (n1>n2? n1 : n2);
  for (int j=0; j<m; j++) {
    int x1=-1,x2=-1;
    if (j<n1) x1 = v1[j];
    if (j<n2) x2 = v2[j];
    if (x1<x2) return false;
  }
  for (int j=0; j<m; j++) {
    int x1=-1,x2=-1;
    if (j<n1) x1 = v1[j];
    if (j<n2) x2 = v2[j];
    if (x1>x2) return true;
  }
  return false;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int elem(vector<int> &v,int j) {
  return (j<int(v.size())? v[j] : -1);
}
#define V1(j) elem(v1,j)
#define V2(j) elem(v2,j)
bool is_greater_than3(vector<int> &v1,vector<int> &v2)  {
  // Retorna true si v1[j]>=v2[j] para todo j
  int n1=v1.size(), n2=v2.size();
  int m = (n1>n2? n1 : n2);
  for (int j=0; j<m; j++) 
    if (V1(j)<V2(j)) return false;
  for (int j=0; j<m; j++) 
    if (V1(j)>V2(j)) return true;
  return false;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int max_sum(vector<vector<int>> &vv)  {
  // Retorna el indice j correspondiente al v[j] que
  // tiene mayor suma
  int jmax=-1,maxsum=-1, nv=vv.size();
  for (int j=0; j<nv; j++) {
    int sum=0;
    vector<int> &vj = vv[j];
    int m=vj.size();
    for (int k=0; k<m; k++) sum += vj[k];
    if (sum>maxsum) { jmax=j; maxsum = sum; }
  }
  return jmax;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int main() {
  Eval ev;
  int vrbs = 0;
  int seed = 123;
  int h1=0,h2=0,h3=0;

#if 0  
  ev.eval<1>(separate,vrbs);
  h1 = ev.evalr<1>(separate,seed,vrbs);
  
  ev.eval<2>(is_greater_than,vrbs);
  h2 = ev.evalr<2>(is_greater_than,seed,vrbs);

  ev.eval<3>(max_sum,vrbs);
  h3 = ev.evalr<3>(max_sum,seed,vrbs);

  printf("S=%03d -> H1=%03d H2=%03d H3=%03d\n",
         seed,h1,h2,h3);
#elif 1
  // Check a specific task
  ev.eval<3>(max_sum,vrbs);
  h3 = ev.evalr<3>(max_sum,seed,vrbs);
  printf("S=%03d -> H1=%03d H2=%03d H3=%03d\n",
         seed,h1,h2,h3);
#elif 0
  // Generate seed/hash tabla
  for (int j=0; j<50; j++) {
    seed = 100+rand()%900;
    if (j==0) seed=123;
    h1 = ev.evalr<1>(extract_range,seed,vrbs);
    h2 = ev.evalr<2>(add_elements,seed,vrbs);
    h3 = ev.evalr<3>(coprimos,seed,vrbs);
    printf("S=%03d -> H1=%03d H2=%03d H3=%03d%s",
           seed,h1,h2,h3,(j%2? "\n" : "          "));
  }
#endif
  return 0;
}
