#define USECHRONO
#include <cassert>
#include <climits>
#include <cstdlib>
#include <stack>
#include "eval.hpp"

using namespace aed;
using namespace std;

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool isin(int x,vector<int> &v) {
  int n=v.size();
  for (int j=0; j<n; j++) {
    if (v[j]==x) {
      v.erase(v.begin()+j);
      return true;
    }
  }
  return false;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool contained2(vector<int> v1,vector<int> v2)  {
  for (auto x1 : v1)
    if (!isin(x1,v2)) return false;
  return true;
}

bool contained(vector<int> &v1,vector<int> &v2)  {
  return contained2(v1,v2) || contained2(v2,v1);
}

bool contained2_sort(vector<int> v1,vector<int> v2)  {
  sort(v1.begin(),v1.end());
  sort(v2.begin(),v2.end());
  int n1=v1.size(), n2=v2.size(), j2=0;
  for (int j1=0; j1<n1; j1++) {
    while (j2<n2 && v2[j2]<v1[j1]) j2++;
    if (j2==n2 || v2[j2]>v1[j1]) return false;
    j2++;
  }
  return true;
}

bool contained_fast(vector<int> &v1,vector<int> &v2)  {
  if (v1.size()<v2.size()) return contained2_sort(v1,v2);
  else return contained2_sort(v2,v1);
}


//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
#define CUBE(j) (j)*(j)*(j)
bool findsum(vector<int> &v,int sumtarget) {
  int n=v.size();
  for (int j=0; j<n-2; j++) {
    for (int k=j+1; k<n-1; k++) {
      for (int l=k+1; l<n; l++) {
        int sumq = CUBE(v[j])+CUBE(v[k])+CUBE(v[l]);
        if (sumq==sumtarget) return true;
      }
    }
  }
  return false;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool findperm2(string base,vector<string> vs,string target) {
  cout << "base \"" << base << "\", vs: ";
  for (auto s : vs) cout << "\"" << s << "\" ";
  cout << ", target: " << target << "\"" << endl;
  if (base==target) return true;
  if (vs.empty()) return false;
  string word = vs[0];
  vs.erase(vs.begin());
  if (findperm2(base+word,vs,target)) return true;
  if (findperm2(word+base,vs,target)) return true;
  if (findperm2(base,vs,target)) return true;
  return false;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool findperm(string partial,vector<string> vs,string target) {
  // cout << "partial: " << partial << endl;
  if (partial==target) return true;
  int ns = vs.size();
  for (int j=0; j<ns; j++) {
    string sj=vs[j];
    vector<string> vsj = vs;
    vsj.erase(vsj.begin()+j);
    if (findperm(partial+sj,vsj,target)) return true;
  }
  return false;
}

bool findperm(vector<string> vs,string target) {
  return findperm(string(""),vs,target);
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool findperm2(vector<string> vs,string target) {
  if (target.empty()) return true;
#if 0  
  cout << "target: " << target << " vs: ";
  for (auto &s : vs) cout << s << " ";
  cout << endl;
#endif
  int ns = vs.size();
  for (int j=0; j<ns; j++) {
    int m = vs[j].size();
    if (target.size()<vs[j].size()) continue;
    if (target.substr(0,m)==vs[j]) {
      vector<string> vsc = vs;
      vsc.erase(vsc.begin()+j);
      int n = target.size();
      if (findperm2(vsc,target.substr(m,n-m)))
        return true;
    }
  }
  return false;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int main() {
  Eval ev;
  int vrbs = 0;

  ev.eval<1>(contained_fast,vrbs);
  ev.eval<2>(findsum,vrbs);
  ev.eval<3>(findperm2,vrbs);

  return 0;
}
