#define USECHRONO
#include <cassert>
#include <climits>
#include <cstdlib>
#include <stack>
#include "eval.hpp"

using namespace aed;
using namespace std;
// COMPLETAR DNI y NOMBRE AQUI:
// Nombre: Esponja, Bob
int DNI=23456789;

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool isinverse(vector<int> &p,vector<int> &q) {
  // Chequea que tengan las mismas condiciones, aunque en
  // realidad eso es un prerequisito. Es deir el usuario
  // debe llamar la función con dos vectores que deben ser
  // permutaciones de la misma cantidad de objetos
  if (p.size()!=q.size()) return false;
  // Chequea que: si k=p[j] => j=q[k]
  int n=p.size();
  for (int j=0; j<n; j++) 
    if (q[p[j]]!=j) return false;
  return true;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void mkmonotone(vector<int> &v,vector<vector<int>> &vv) {
  // Limpiar el contenedor de salida
  vv.clear();
  // q itera sobre los elementos del vector de entrada
  auto q = v.begin();
  while (q!=v.end()) {
    // TMP es un vector temporario donde vamos apendizando
    // los elementos de la siguiente subsecuencia monotona
    vector<int> tmp;
    // LAST es el ultimo elemento de la subsecuencia que chequeamos
    int last=*q;
    // Vamos comparando con el siguiente elemento y avanzamos
    while (q!=v.end() && *q>=last) {
      tmp.push_back(*q); last=*q++;
    }
    // Insertamos el temporario en el contenedor de salida
    vv.push_back(tmp);
  }
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void mkmonotone2(vector<int> &v,vector<vector<int>> &vv) {
  // Este es similar, pero itera con un contador, no con iteradores
  vv.clear();
  int j=0;
  int n= v.size();
  while (j<n) {
    // TMP es el vector temporario donde ponemos la siguiente secuencia
    vector<int> tmp;
    // Insertamos el primer elemento
    tmp.push_back(v[j++]);
    // Recorremos tantos elementos como podemos mientras la
    // secuencia sea monotona
    while (j<n && v[j-1]<=v[j]) 
      tmp.push_back(v[j++]);
    // Insertamos el TMP en el contenedor de salida
    vv.push_back(tmp);
  }
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool incluido(vector<int> &v1,vector<int> &v2) {
  // Tamano de los contenedores
  int n1=v1.size();
  int n2=v2.size();
  // No hace falta chequear si n2<=n1 porque caso contrario
  // el lazo iria hasta n2-n1 que es negativo y por lo tanto
  // no se ejecuta el lazo
  for (int k=0; k<n1-n2; k++) {
    // Comparamos el rango [0,n2) en V2 con el rango
    // [k,j+n2) en V1, Si encontramos alguno diferente
    // ya el rango no es igual y por lo tanto pasamos al siguiente indice
    // son iguales retornamos TRUE
    int j;
    for (j=0; j<n2; j++) if (v2[j]!=v1[k+j]) break;
    // Si recorrimos todo el lazo sin hacer break quiere
    // decir que los rangos son iguales. En ese caso el
    // indice J sale con el valor N2
    if (j==n2) return true;
  }
  return false;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int main() {
  Eval ev;
  int vrbs = 0;

  ev.eval<1>(isinverse,vrbs);
  ev.eval<2>(mkmonotone,vrbs);
  ev.eval<2>(mkmonotone2,vrbs);
  ev.eval<3>(incluido,vrbs);
  return 0;
}
