#include "eval.hpp"

using namespace aed;
using namespace std;

int hasx(vector<int>&v,int x) {
  int N = v.size();
  for (int j=0; j<N; j++)
    if (v[j]==x) return 1;
  return 0;
}

int countsets(vector< vector<int> > &VV,int x) {
  int N = VV.size();
  int rv = 0;
  for (int j=0; j<N; j++) rv += hasx(VV[j],x);
  return rv;
}

int max_mseq(vector<int> &w,int m) {
  if (w.size()<m) return -1;
  int j0=0, j1=m;
  int smax=0;
  for (int j=0; j<m; j++) smax+=w[j];
  int sz = w.size(), s=smax;
  while (j1<sz) {
    s += w[j1]-w[j0];
    if (s>smax) smax=s;
    j0++; j1++;
  }
  return smax;
}

int badpwd(string &oldpwd,string &newpwd) {
  int N=oldpwd.size();
  if (newpwd.size()!=N) return 0;
  if (oldpwd==newpwd) return 1;
  
  for (int n1=0; n1<=N; n1++) {
    for (int n2=0; n2<=N; n2++) {
      if (n1+n2>N) break;
      int n3 = N-(n1+n2);
      string
        s1 = oldpwd.substr(0,n1),
        s2 = oldpwd.substr(n1,n2),
        s3 = oldpwd.substr(n1+n2,n3);
      if (s1+s2+s3 == newpwd) return true;
      if (s1+s3+s2 == newpwd) return true;
      if (s2+s1+s3 == newpwd) return true;
      if (s2+s3+s1 == newpwd) return true;
      if (s3+s1+s2 == newpwd) return true;
      if (s3+s2+s1 == newpwd) return true;
    }
  }
  return false;
}

void check(string oldpwd,string newpwd) {
  const char *s = (badpwd(oldpwd,newpwd)? "BAD" : "GOOD");
  printf("%s/%s -> %s\n",oldpwd.c_str(),newpwd.c_str(),s);
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void larger_odd_subvec(vector< vector<int> > &VV,vector<int> &oddmax) {
  oddmax.clear();
  int N = VV.size();
  for (int j=0; j<N; j++) {
    vector<int> w, &vvj = VV[j];
    int m = vvj.size();
    for (int l=0; l<m; l++) if (vvj[l]%2!=0) w.push_back(vvj[l]);
    if (w.size()>oddmax.size()) oddmax = w;
  }
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int main() {
  Eval ev;
  int vrbs = 0;

#if 1
  ev.eval1(countsets,vrbs);
  ev.eval2(max_mseq,vrbs);
  ev.eval3(badpwd,vrbs);
  ev.eval4(larger_odd_subvec,vrbs);
#else
  ev.evalr3(badpwd,vrbs);
#endif

  return 0;
}
