#define USECHRONO
#include <cassert>
#include <climits>
#include <cstdlib>
#include <stack>
#include "eval.hpp"

using namespace aed;
using namespace std;

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void occurm(vector<int> &v,int m,vector<int> &vm) {
  vm.clear();
  for (unsigned int j=0; j<v.size(); j++) {
    int vj = v[j];
    int OK=1;
    // Look if vj is in vm
    for (unsigned int k=0; k<vm.size(); k++)
      if (vm[k]==vj) { OK=0; break; }
    if (OK) {
      // Count how many times it is contained in v1
      int count=0;
      for (unsigned int k=0; k<v.size(); k++) count += (v[k]==vj);
      if (count==m) vm.push_back(vj);
    }
  }
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int count(vector<int> &v,int x) {
  int rv =0;
  for (unsigned int j=0; j<v.size(); j++)
    rv += (v[j]==x);
  return rv;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void occurm2(vector<int> &v,int m,vector<int> &vm) {
  vm.clear();
  for (unsigned int j=0; j<v.size(); j++) {
    int vj=v[j];
    if (count(vm,vj)==0 && count(v,vj)==m)
      vm.push_back(vj);
  }
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int sumsubv(vector<int> &v,int j1,int j2) {
  int sum=0;
  for (int j=j1; j<j2; j++) sum += v[j];
  return sum;
}
  
//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void subvmax(vector<int>&v, vector<int> &subv) {
  int n=v.size(), smax=-1, J1=-1, J2=-1;
  for (int j1=0; j1<n; j1++) 
    for (int j2=j1; j2<=n; j2++) {
      int s = sumsubv(v,j1,j2);
      // cout << j1 << " " << j2 << " " << s << endl;
      if(s>smax) { smax=s; J1=j1; J2=j2; }
    }
  // cout << "max J1,J2 " << J1 << " " << J2 << endl;
  subv.clear();
  for (int j=J1; j<J2; j++) subv.push_back(v[j]);
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool subvector(vector<int> &v1,vector<int> &v2) {
  unsigned int n1=v1.size();
  for (unsigned int j=0; j<n1; j++) {
    if (n1-j<v2.size()) return false;
    unsigned int k;
    for (k=0; k<v2.size(); k++)
      if (v1[j+k]!=v2[k]) break;
    if (k>=v2.size()) return true;
  }
  return false;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int main() {
  Eval ev;
  int vrbs = 0;
  int seed = 123;
  int h1=0,h2=0,h3=0;

#if 0
  ev.eval<1>(occurm,vrbs);
  h1 = ev.evalr<1>(occurm,seed,vrbs);

  ev.eval<2>(subvmax,vrbs);
  h2 = ev.evalr<2>(subvmax,seed,vrbs);
  
  ev.eval<3>(subvector,vrbs);
  h3 = ev.evalr<3>(subvector,seed,vrbs);

  printf("S=%03d -> H1=%03d H2=%03d H3=%03d\n",
         seed,h1,h2,h3);
#elif 1
  ev.eval<2>(subvmax,vrbs);
  h2 = ev.evalr<2>(subvmax,seed,vrbs);
  // #include "./tasks.cpp"
#endif
  return 0;
}
