#define USECHRONO
#include <cassert>
#include <climits>
#include <cstdlib>
#include <stack>
#include "eval.hpp"

using namespace aed;
using namespace std;
using namespace nlohmann;
// COMPLETAR DNI y NOMBRE AQUI:
// Nombre: Esponja, Bob
int DNI=23456789;

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool disjoint(set<int> &A,set<int> &B) {
  // Calcula la interseccion de A y B.
  // Son disjuntos si la interseccion es vacia
  // OJO hay que usar un temporario por el tema del overlapping
  set<int> tmp;
  set_intersection(A.begin(),A.end(),B.begin(),B.end(),
                   inserter(tmp,tmp.begin()));
  return tmp.empty();
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void keepset(list<set<int>> &LS, list<set<int>> &good, list<set<int>> &bad) {
  // Itera sobre los conjuntos de LS
  auto p = LS.begin();
  while(p!=LS.end()) {
    // OK va a ser true si tiene que quedar
    bool OK = false;
    // Chequea que al menos uno de los GOOD no sea disjunto
    for (auto &s : good) if (!disjoint(s,*p)) { OK=true; break; }
    // Chequea que ninguno de los BAD sea disjunto
    for (auto &s : bad) if (!disjoint(s,*p)) { OK=false; break; }
    // Si no pasa todos los test entonces lo borramos
    // OJO o se avanza o se borra
    if (OK) p++;
    else p = LS.erase(p);
  }
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool equivlset(list<set<int>> &LSA,list<set<int>> &LSB) {
  // Pone todos los elementos en las listas LA y LB
  list<int> LA,LB;
  for (auto &s : LSA) 
    for (auto x : s) LA.push_back(x);
  for (auto &s : LSB)
    for (auto x : s) LB.push_back(x);
  // Ordenamos las listas
  LA.sort();
  LB.sort();
  // Comparamos directamente las listas
  return LA==LB;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
bool equivlsetmap(list<set<int>> &LSA,list<set<int>> &LSB) {
  // Vamos contanto las ocurrencias de un dado x en cada uno de los A y B
  map<int,int> MA,MB;
  for (auto &s : LSA) for (auto x : s) MA[x]++;
  for (auto &s : LSB) for (auto x : s) MB[x]++;
  // Comparamos directamente los maps
  return MA==MB;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int main() {
  Eval ev;
  int vrbs=0;
  ev.eval<1>(keepset,vrbs);
  ev.eval<2>(equivlset,vrbs);
  ev.eval<2>(equivlsetmap,vrbs);

  return 0;
}
