#define USECHRONO
#include <cassert>
#include <climits>
#include <cstdlib>
#include <stack>
#include "eval.hpp"

using namespace aed;
using namespace std;
using namespace nlohmann;
// COMPLETAR DNI y NOMBRE AQUI:
// Nombre: Esponja, Bob
int DNI=23456789;

int max(int x,int y) { return x>y? x : y; }

int maxtree(json &tree) {
  if (tree.is_number()) return tree.get<int>();
  int tmax=tree[0].get<int>();
  int nchild=tree.size()-1;
  for (int j=0; j<nchild; j++) 
    tmax = max(tmax,maxtree(tree[j+1]));
  return tmax;
}

int maxleaf(json &tree) {
  if (tree.is_number()) return tree.get<int>();
  int tmax=0;
  int nchild=tree.size()-1;
  for (int j=0; j<nchild; j++) 
    tmax = max(tmax,maxleaf(tree[j+1]));
  return tmax;
}

int maxdepth(json &tree) {
  if (tree.is_number()) return 0;
  int retv=0;
  int nchild=tree.size()-1;
  for (int j=0; j<nchild; j++) 
    retv = max(retv,maxdepth(tree[j+1]));
  return retv+1;
}

void xcloser(MatrixXd &vert,VectorXd &x,VectorXd &y) {
  int ndim=vert.rows(),na=(ndim+1),m=2*na+1;
  assert(vert.cols()==na);
  MatrixXd A(m,m);
  A.fill(0.0);
  A.block(0,0,na,na) = vert.transpose()*vert;
  A.block(na,0,1,na).fill(1.0);
  A.block(0,na,na,1).fill(1.0);
  // f==1 are the active restrictions
  VectorXd f(na);
  f.fill(0.0);
  double tol=1e-7;
  VectorXd alpha(na);
  int iter;
  while (1) {
    // ESHV(f);
    MatrixXd F = f.asDiagonal();
    MatrixXd IF = MatrixXd::Identity(na,na)-F;
    A.block(na+1,0,na,na) = F;
    A.block(0,na+1,na,na) = F;
    A.block(na+1,na+1,na,na) = IF;
    // ESHV(A);
  
    VectorXd rhs(m);
    rhs.fill(0.0);
    rhs.segment(0,na) = vert.transpose()*x;
    rhs(na)=1;
    // ESHV(rhs);
    VectorXd  xx = A.lu().solve(rhs);
    // ESHV(xx);
    alpha = xx.segment(0,na);
    double alphamin= alpha.minCoeff();
    // cout << "alphamin " << alphamin << endl;
    if (alphamin>-tol) break;
    int nf=0; 
    for (int j=0; j<na; j++) {
      f(j) = f(j) || (alpha(j)<-tol);
      nf += f(j);
    }
    // printf("iter %d, nf %d\n",iter,nf);
    iter++;
  }
  y = vert*alpha;
  // exit(0);
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int main() {
  int seed=123,vrbs=0;

  // eval1_t eval1;
  // eval1.evfun(vrbs);

  // eval2_t eval2;
  // eval2.evfun(vrbs);

  eval3_t eval3;
  eval3.evfun(vrbs);
  
  return 0;
}

