#define USECHRONO
#include <cassert>
#include <climits>
#include <cstdlib>
#include <stack>
#include "eval.hpp"

using namespace aed;
using namespace std;
using namespace nlohmann;
// COMPLETAR DNI y NOMBRE AQUI:
// Nombre: Esponja, Bob
int DNI=23456789;

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
set<int> intsermax(vector<set<int>> &VS,set<int> &Q) {
  set<int> Smax;
  unsigned int nmax=0;
  for (auto &Sj : VS) {
    set<int> tmp;
    set_intersection(Sj.begin(),Sj.end(),
                     Q.begin(),Q.end(),
                     inserter(tmp,tmp.begin())) ;
    if (tmp.size()>nmax) { nmax=tmp.size(); Smax = Sj; }
  }
  return Smax;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void flatten(json &nested,json &flat) {
  if (nested.is_array()) {
    for (auto &x : nested) flatten(x,flat);
  } else if (nested.is_object()) {
    for (auto &q : nested.items()) {
      flat.push_back(q.key());
      flatten(q.value(),flat);
    }
  } else {
    flat.push_back(nested);
  }
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
double maxvol2(MatrixXd &xnodes) {
  int nnod=xnodes.rows();
  MatrixXd xvert(4,4);
  xvert.fill(1.0);
  double Maxvol=0.0;
  for (int j0=0; j0<nnod-3; j0++) {
    xvert.block(0,0,1,3) = xnodes.block(j0,0,1,3);
    for (int j1=j0+1; j1<nnod-2; j1++) {
      xvert.block(1,0,1,3) = xnodes.block(j1,0,1,3);
      for (int j2=j1+1; j2<nnod-1; j2++) {
        xvert.block(2,0,1,3) = xnodes.block(j2,0,1,3);
        for (int j3=j2+1; j3<nnod; j3++) {
          xvert.block(3,0,1,3) = xnodes.block(j3,0,1,3);
          double vol = xvert.determinant()/6.0;
          Maxvol = (vol>Maxvol? vol : Maxvol);
        }
      }
    }
  }
  return Maxvol;
}

void flatten2(json &nested,json &flat) {
  for (unsigned int j = 0; j < nested.size();j++){
    if (nested[j].is_number()){flat.push_back(nested[j]); }
    else if (nested[j].is_string()){ 
      flat.push_back(nested[j]);
    }
    else if (nested[j].is_array()){
      flatten2(nested[j],flat);
    }
    else {
      flat.push_back("[null]");

    } 
  }
}

// void flatten(json &nested,json &flat) {
//   flatten3(nested,flat);
//   if (flat.is_null()) flat.push_back(nullptr);
// }

double maxvol(MatrixXd &xnodes) {
  int nnod=xnodes.rows();
  MatrixXd xvert(4,4);
  xvert.fill(1.0);
  double Maxvol=0.0;
  for (int j0=0; j0<nnod; j0++) {
    xvert.block(0,0,1,3) = xnodes.block(j0,0,1,3);
    for (int j1=0; j1<nnod; j1++) {
      xvert.block(1,0,1,3) = xnodes.block(j1,0,1,3);
      for (int j2=0; j2<nnod; j2++) {
        xvert.block(2,0,1,3) = xnodes.block(j2,0,1,3);
        for (int j3=0; j3<nnod; j3++) {
          xvert.block(3,0,1,3) = xnodes.block(j3,0,1,3);
          double vol = xvert.determinant()/6.0;
          Maxvol = (vol>Maxvol? vol : Maxvol);
        }
      }
    }
  }
  return Maxvol;
}

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
int main() {
  int vrbs=0;

  eval1_t eval1;
  eval1.evfun(vrbs);

  eval2_t eval2;
  eval2.evfun(vrbs);

  eval3_t eval3;
  eval3.evfun(vrbs);
  
  return 0;
}

